/*
 * Copyright (c) 1995, 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#include <mom/compiler.h>
#include <mom/c/libcast.h>

cast_type cast_new_struct_type(int slots)
{
	cast_type type = cast_new_type(CAST_TYPE_STRUCT);
	cast_struct_type *st = &(type->cast_type_u_u.struct_type);
	
	if (slots > 0) {
		st->slots.slots_len = slots;
		st->slots.slots_val = mustcalloc(slots
						 * sizeof(cast_struct_slot));
	} else {
		st->slots.slots_val = 0;
		st->slots.slots_len = 0;
	}
	
	return type;
}

/* End of file. */

