/*
 * Copyright (c) 1996, 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#include <assert.h>
#include "iiop.h"

/* Output the bad `CORBA_BOA_obj_is_ready' examples?  No. */
#define BAD_EXAMPLE 0

void
do_main_output(pres_c_1 *p)
{
	int i, header = 0;
	// Build a list of funcs to work on
	for (i = 0; i < (signed int)p->stubs.stubs_len; i++) {
		if (p->stubs.stubs_val[i].kind == PRES_C_SERVER_SKEL) {
			if (!header) {
				w_printf("#include <assert.h>\n");
				w_printf("#include <stdio.h>\n");
				w_printf("\n/* You need to implement this function (return 0 for success) */");
				w_printf("\nint register_objects(CORBA_ORB, CORBA_BOA, int argc, char **argv);\n");
				w_printf("\nint main(int argc, char **argv)\n{\n");
				w_printf("\tCORBA_ORB orb;\n");
				w_printf("\tCORBA_BOA boa;\n");
				w_printf("\tif (argc < 3) {\n");
				w_printf("\t\tfprintf(stderr, \"usage: %%s [-ORBipaddr (local host ip address)] -OAport (portnum) ...\\n\", argv[0]);\n");
				w_printf("\t\texit(1);\n\t}\n");
				w_printf("\n\torb = CORBA_ORB_init(argc, argv);\n");
				w_printf("\tif (!orb) {\n");
					w_printf("\t\tfprintf(stderr, \"Error: unable to initialize ORB.\\n\");\n");
					w_printf("\t\texit(1);\n");
				w_printf("\t}\n");
				w_printf("\tboa = CORBA_ORB_BOA_init(orb, argc, argv);\n");
				w_printf("\tif (!boa) {\n");
					w_printf("\t\tfprintf(stderr, \"Error: unable to initialize Object adapter.\\n\");\n");
					w_printf("\t\texit(1);\n");
				w_printf("\t}\n");
				w_printf("\tif (!register_objects(orb, boa, argc, argv)) {\n");
#if BAD_EXAMPLE
/* XXX --- The `CORBA_BOA_obj_is_ready' example invocations are wrong! */
					w_printf("#if 0\n");
					w_printf("\t\t/* call CORBA_BOA_obj_is_ready for every object instance \n");
					w_printf("\t\t   of an interface you want.  Here are some examples: */\n\n");
#endif /* BAD_EXAMPLE */
				header = 1;
			}
#if BAD_EXAMPLE
			pres_c_server_skel skel = p->stubs.stubs_val[i].pres_c_stub_u.sskel;
			cast_def *cdef = &p->cast.cast_scope_val[skel.c_def];
			w_printf("\t\tCORBA_BOA_obj_is_ready(boa, &%s, \"%s_instance1\");\n", cdef->name, cdef->name);
			w_printf("\t\tCORBA_BOA_obj_is_ready(boa, &%s, \"%s_instance2\");\n\n", cdef->name, cdef->name);
#endif /* BAD_EXAMPLE */
		}
	}
	if (header) {
#if BAD_EXAMPLE
			w_printf("#endif\n");
#endif /* BAD_EXAMPLE */
			w_printf("\n\t\tCORBA_BOA_impl_is_ready(boa);\n");
		w_printf("\t} else {\n");
			w_printf("\t\tfprintf(stderr, \"Error: unable to register object implementations.\\n\");\n");
			w_printf("\t\texit(1);\n");
		w_printf("\t}\n");
		w_printf("\treturn 0;\n}\n");
	}
}

/* End of file. */

