/*
 * Copyright (c) 1997 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 *
 * This file is part of Flick, the Flexible IDL Compiler Kit.
 *
 * Flick is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Flick is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Flick; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place #330, Boston, MA 02111, USA.
 */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <flick/link/suntcp.h>
#ifndef RPCGEN
#include "parms-client.h"
#else
#include "parms.h"
#endif

int main(int argc, char **argv) 
{
	CLIENT tmp, *c;
	FLICK_SERVER_LOCATION s;
	int i = 50000;
	int *val;
	c = &tmp;
	if (argc != 2) {
		fprintf(stderr, "Usage: %s <host>\n", argv[0]);
		exit (1);
	}
  
	s.server_name = argv[1];
	s.prog_num = parm;
	s.vers_num = one;
	create_client(c, s);
#define SHOWTST(prn)				\
	printf("arg:\t"#prn"\n",arg);		\
	if (res)				\
		printf("res:\t"#prn"\n",*res);	\
	else					\
		fprintf(stderr, "Failed to receive _ANY_ result\n");
  
#define RUNTST(type, name, init1, init2, prn) {		\
		type arg, tmp, *res;			\
		arg = init1;				\
		tmp = init2;				\
		res = &tmp;				\
		printf("Before calling "#name"\n");	\
		SHOWTST(##prn);				\
		printf("After calling "#name"\n");	\
		res = ##name##_test_2345(&arg, c);	\
		SHOWTST(##prn);				\
	}
  
/*  RUNTST(void,void,0,0,%x);*/
	RUNTST(char,char,'a','b',%c);
	RUNTST(int,bool,1,234,%d);
	RUNTST(short,short,123,234,%d);
	RUNTST(unsigned short,ushort,123,234,%d);
	RUNTST(int,long,66000,77777,%d);
	RUNTST(unsigned int,ulong,123454,543211,%d);
	RUNTST(float, float, 1.234, 4.321, %f);
	RUNTST(double, double, 1.234567890123, 9.876543210987, %f);
	return 0;
}

/* End of file. */

